<?php
namespace Teknisa\GOP\Services;

 use Zeedhi\Framework\DataSource\DataSet;
 use Zeedhi\Framework\DTO;


class Gop10000CalculoOrcamentoOperacionalService{
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function beginTransaction () {
        $this->connection->beginTransaction();
    }
    
    public function commit () {
        $this->connection->commit();
    }
    
    public function rollback () {
        $this->connection->rollback();
    }
    
    public function getParamOrca(){
        $query = "SELECT IDORCADESPMATRI, IDORCDESPDIVERS FROM PARAMORCAOPERAC";
        try{
            
            $std = $this->connection->prepare($query);
            $std->execute();
            $result = $std->fetchAll();
            return $result[0];
            
        }catch (Exception $e){
            throw $e;
        }
    }
    
    public function getParamGeral () 
    {
        $query = "SELECT IDSISDOS FROM PARAMGERAL WHERE NRORG = :NRORG";
        
        $param = array("NRORG" => $this->environment->getNrOrgTrab());
        
        try{
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            $retorno = $std->fetchAll();
            
            return $retorno;
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function findNritorcamesgop($params){
        
        $query = "SELECT O.CDFILIAL, P.DTMESBASEITEM, IM.VRORCAMENTO, IM.NRITORCAMESGOP
                     FROM ORCAMENTOGOP O INNER JOIN ITEMORCAGOP P ON O.NRORCAMENTOGOP = P.NRORCAMENTOGOP 
                                          INNER JOIN ITORCAMESGOP IM ON P.NRITEMORCAOP = IM.NRITEMORCAOP 
                    WHERE P.NRITEMORCAOP = :P_NRITEMORCAOP 
                      AND O.NRANOORCAGOP = :P_NRANOORCAGOP 
                      AND O.IDPERIODOORCA = :P_IDPERIODOORCA 
                      AND O.NRPERIODOORCA = :P_NRPERIODOORCA 
                      AND TO_NUMBER(TO_CHAR(IM.DTORCAMENTO, 'MM')) = :P_MES 
                      AND (O.CDFILIAL = :P_CDFILIAL OR :P_CDFILIAL = 'T')";
        try{
            $std = $this->connection->prepare($query);
            $std->execute($params); //apenas executa
            $retorno = $std->fetchAll();  //retorna
            return $retorno;
        }catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateMesBase($params){
        
        $sqlUpdate = "UPDATE ITEMORCAGOP
		                 SET DTMESBASEITEM = :P_DTMESBASEITEM
		               WHERE NRITEMORCAOP   = :P_NRITEMORCAOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateMeses($params){
        
        $sqlUpdate = "UPDATE ITORCAMESGOP
                         SET VRORCAMENTO = :VRORCAMENTO
                       WHERE NRITORCAMESGOP = :NRITORCAMESGOP
                         AND NRITEMORCAOP = :NRITEMORCAOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateTotalDetalhe($data){
        
        $dataSet = $data[0];  
        try{
        
            if( $dataSet["itemorca"] ==='MAOOBRA'){
                
                $sqlUpdate ="UPDATE ITORCAMESGOP 
                            SET IDALTMANUAL = 'S',
                            NRITORCAMESGOP  = :NRITORCAMESGOP,
                            VRORCAMENTO     = :VRORCAMENTO,
                            VRPERCENTUAL    = :VRPERCENTUAL,
                            VRTOTALMES      = :VRTOTALMES
                            
                            WHERE NRITORCAMESGOP = :NRITORCAMESGOP";
                
                foreach($dataSet["itensDetalhe"] as $index):
                    $parametros = array(
                        ":NRITORCAMESGOP" => $index ["NRITORCAMESGOP"],
                        ":VRORCAMENTO"    => $index ["VRORCAMENTO"],
                        ":VRPERCENTUAL"   => $index ["VRPERCENTUAL"],
                        ":VRTOTALMES"     => isset($index ["VRTOTALMES"]),
                    );
                    
                    $std = $this->connection->prepare($sqlUpdate);
                    $std->execute($parametros);
               endforeach;
                
    
            }else{
                
                $sqlUpdate = "UPDATE ITDETALORCAMESGOP
                         SET VRORCAMENTO  = :VRORCAMENTO,
                             VRPERCENTUAL = :VRPERCENTUAL
     
                       WHERE NRITDETALORCAMESGOP = :NRITDETALORCAMESGOP
                         AND NRITORCAMESGOP      = :NRITORCAMESGOP";
                         
                try {
                    
                    $vrtotItem = 0;
                    foreach($dataSet["itensDetalhe"] as $index):
                        
                        $vrtotItem = $vrtotItem + $index ["VRORCAMENTO"];
                        
                        $params = array(
                            ":NRITDETALORCAMESGOP" => $index ["NRITDETALORCAMESGOP"],
                            ":NRITORCAMESGOP"      => $index ["NRITORCAMESGOP"],
                            ":VRORCAMENTO"         => $index ["VRORCAMENTO"],
                            ":VRPERCENTUAL"        => $index ["VRPERCENTUAL"],
                        );
                        
                        $std = $this->connection->prepare($sqlUpdate);
                        $std->execute($params);
                        
    
                    endforeach;
                    
                    /*Updata o TOTAL obtido acima(variável $vrtotItem)
                     no campo VOROCAMENTO da tabela  ITORCAMESGOP*/
                    $sqlItorcamesgop = "UPDATE ITORCAMESGOP
                                     SET VRORCAMENTO    = :VRORCAMENTO
                                   WHERE NRITORCAMESGOP = :NRITORCAMESGOP";
                                   
                    $paramsItorcamesgop = array(
                        ":NRITORCAMESGOP"  => $index ["NRITORCAMESGOP"],
                        ":VRORCAMENTO"     => $vrtotItem
                    );
                    
                    $stdItorcamesgop = $this->connection->prepare($sqlItorcamesgop);
                    $stdItorcamesgop->execute($paramsItorcamesgop);
                    
                    

                } catch (Exception $e){
                    throw $e;
                }
            }
        }catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateDetalheImposto($data){

           	
        foreach($data as $row){
            
        	$parametros = array(
                ":VRORCAMENTO"    => $row["VRORCAMENTO"],
                ":VRPERCENTUAL"   => $row["VRPERCENTUAL"],
				":P_NRITEMORCAOP" => $row["NRITEMORCAOP"],
                ":P_MES" => $row["MES"]
            );
            
            $sqlUpdate = "UPDATE ITORCAMESGOP
                             SET VRORCAMENTO  = :VRORCAMENTO,
                                 VRPERCENTUAL = :VRPERCENTUAL
                           WHERE NRITEMORCAOP = :P_NRITEMORCAOP
                             AND TO_NUMBER(TO_CHAR(DTORCAMENTO, 'MM')) = :P_MES";
            try {
                $std = $this->connection->prepare($sqlUpdate);
                $std->execute($parametros);
            } catch (Exception $e){
                throw $e;
            }
                
        }

    }
    
    public function updateTotalImposto($params, $nritemorcaop){
        $sqlUpdate = "UPDATE ITORCAMESGOP
                         SET IDALTMANUAL = 'S',
                             VRTOTALMES = :VRTOTALMES
                       WHERE NRITEMORCAOP IN (". $nritemorcaop .")
                         AND TO_NUMBER(TO_CHAR(DTORCAMENTO, 'MM')) = :P_MES";
        try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    

    public function updateDetalheDespesaMo($params){
        $sqlUpdate = "UPDATE ITDETALORCAMESGOP 
                         SET VRORCAMENTO    = :VRORCAMENTO 
                       WHERE NRITDETALORCAMESGOP = :NRITDETALORCAMESGOP";
        try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateDetalheMesDespesaMO($params){
        $sqlUpdate = "UPDATE ITORCAMESGOP
                        SET VRORCAMENTO = :VRORCAMENTOMES
                       WHERE NRITORCAMESGOP = :NRITORCAMESGOP";
                       
        $std = $this->connection->prepare($sqlUpdate);
        $std->execute($params);
    }
    
    public function updateItem($params){
        $sqlUpdate = "UPDATE ITDETALORCAMESGOP
                         SET VRORCAMENTO = :VRORCAMENTO
                       WHERE NRITDETALORCAMESGOP = :NRITDETALORCAMESGOP
                         AND NRITORCAMESGOP = :NRITORCAMESGOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function atualizaItemTotal($params){
        $sqlUpdate = "UPDATE ITORCAMESGOP
		                 SET VRORCAMENTO = (SELECT SUM(VRORCAMENTO)
		                					  FROM ITDETALORCAMESGOP
                                             WHERE NRITORCAMESGOP = :P_NRITORCAMESGOP)
		               WHERE NRITORCAMESGOP = :P_NRITORCAMESGOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            array_push($erroList, "Nao foi possivel processar os dados enviados --- " . $ex->getMessage());
            return $erroList;
        }
    }
    
    public function getNranoorcagop($params){
        $sqlUpdate = "SELECT DISTINCT NRANOORCAGOP FROM ORCAMENTOGOP ORDER BY NRANOORCAGOP DESC";
       try {
            $std = $this->connection->prepare($select);
            $std->execute($params); //apenas executa
            $retorno = $std->fetchAll();  //retorna
            return $retorno;
        } catch (Exception $e){
            array_push($erroList, "Nao foi possivel processar os dados enviados --- " . $ex->getMessage());
            return $erroList;
        }
    }

    public function getMes($mes){
        if($mes == 1){
            return "JANEIRO";
        }else if($mes == 2){
            return "FEVEREIRO";
        }else if($mes == 3){
            return "MARCO";
        }else if($mes == 4){
            return "ABRIL";
        }else if($mes == 5){
            return "MAIO";
        }else if($mes == 6){
            return "JUNHO";
        }else if($mes == 7){
            return "JULHO";
        }else if($mes == 8){
            return "AGOSTO";
        }else if($mes == 9){
            return "SETEMBRO";
        }else if($mes == 10){
            return "OUTUBRO";
        }else if($mes == 11){
            return "NOVEMBRO";
        }else if($mes == 12){
            return "DEZEMBRO";
        }
    }
    
    public function confirmContabil($rows, $rowsChecked, $nrLista, $nrListaFilial) {
        $sqlScript="DECLARE
                       V_ORCADO FLOAT;
                       V_CDORCAMENT VARCHAR2(04);
                       V_ANO VARCHAR2(04);
                    BEGIN
                       FOR C_ORC IN (SELECT DT.NRITDETALORCAMESGOP, DT.CDCONTCTBL, M.DTORCAMENTO, O.CDFILIAL, O.NRANOORCAGOP, O.IDPERIODOORCA, 
                                            O.NRPERIODOORCA, I.IDTIPOORCAOP
                                       FROM ORCAMENTOGOP O INNER JOIN ITEMORCAGOP I ON I.NRORCAMENTOGOP = O.NRORCAMENTOGOP
                                                                                  AND I.IDTIPOORCAOP = :P_IDTIPOORCAOP
                                                           INNER JOIN ITORCAMESGOP M ON M.NRITEMORCAOP = I.NRITEMORCAOP
                                                                                    --AND M.DTORCAMENTO = V_MES
                                                           INNER JOIN ITDETALORCAMESGOP DT ON DT.NRITORCAMESGOP = M.NRITORCAMESGOP
                                                           INNER JOIN LISTA L ON L.CDLISTA = O.CDFILIAL
                                      WHERE O.NRANOORCAGOP = :P_ANO
                                        AND O.IDPERIODOORCA = :P_IDPERIODOORCA
                                        AND O.NRPERIODOORCA = :P_NRPERIODOORCA 
                                        AND L.NRLISTA = :P_NRLISTAFILIAL
                                        AND DT.CDCONTCTBL IS NOT NULL) LOOP 
                                        
                         SELECT ABS(NVL(SUM(VRITEMORCA), 0))
                           INTO V_ORCADO
                           FROM ITEMORCA I 
                                INNER JOIN LISTA L ON L.CDLISTA = I.CDCENTCUST
                          WHERE I.CDFILIAL = C_ORC.CDFILIAL
                            AND I.CDORCAMENT = :P_CDORCAMENT
                            AND LENGTH (I.CDCONTCTBL) = (SELECT LENGTH (REPLACE(CDPICTCCTB, '.', '')) CDPICTCCTB FROM PARAMGERAL WHERE CDPARGERAL = '0001')
                            AND I.CDCONTCTBL LIKE C_ORC.CDCONTCTBL||'%'
                            AND I.DTITEMORCA BETWEEN TRUNC (C_ORC.DTORCAMENTO, 'MM') AND LAST_DAY(C_ORC.DTORCAMENTO)
                            AND L.NRLISTA = :P_NRLISTA;
                            
                         UPDATE ITDETALORCAMESGOP
                            SET VRORCAMENTO = V_ORCADO
                          WHERE NRITDETALORCAMESGOP = C_ORC.NRITDETALORCAMESGOP; 
                        
                        UPDATE (SELECT M.VRORCAMENTO, M.NRITORCAMESGOP 
                                  FROM ORCAMENTOGOP O INNER JOIN ITEMORCAGOP I ON O.NRORCAMENTOGOP = I.NRORCAMENTOGOP
                                                                              AND O.CDFILIAL = I.CDFILIAL 
                                                                              AND I.IDTIPOORCAOP = C_ORC.IDTIPOORCAOP
                                                      INNER JOIN ITORCAMESGOP M ON M.NRITEMORCAOP = I.NRITEMORCAOP 
                                 WHERE O.NRANOORCAGOP = C_ORC.NRANOORCAGOP
                                   AND O.CDFILIAL = C_ORC.CDFILIAL
                                   AND O.IDPERIODOORCA = C_ORC.IDPERIODOORCA
                                   AND O.NRPERIODOORCA = C_ORC.NRPERIODOORCA
                                   AND M.DTORCAMENTO = C_ORC.DTORCAMENTO) X
                          SET X.VRORCAMENTO = (SELECT SUM(D.VRORCAMENTO)
                                                 FROM ITDETALORCAMESGOP D
                                                WHERE D.NRITORCAMESGOP = X.NRITORCAMESGOP);
                                                
                       UPDATE (SELECT D.VRORCAMENTO, D.VRPERCENTUAL, M.VRORCAMENTO TOTAL
                                 FROM ORCAMENTOGOP O INNER JOIN ITEMORCAGOP I ON O.NRORCAMENTOGOP = I.NRORCAMENTOGOP
                                                                             AND O.CDFILIAL = I.CDFILIAL
                                                                             AND I.IDTIPOORCAOP = C_ORC.IDTIPOORCAOP 
                                                     INNER JOIN ITORCAMESGOP M ON M.NRITEMORCAOP = I.NRITEMORCAOP
                                                     INNER JOIN ITDETALORCAMESGOP D ON D.NRITORCAMESGOP = M.NRITORCAMESGOP
                                WHERE O.NRANOORCAGOP = C_ORC.NRANOORCAGOP
                                  AND O.CDFILIAL = C_ORC.CDFILIAL
                                  AND O.IDPERIODOORCA = C_ORC.IDPERIODOORCA
                                  AND O.NRPERIODOORCA = C_ORC.NRPERIODOORCA 
                                  AND M.DTORCAMENTO = C_ORC.DTORCAMENTO) X
                         SET  X.VRPERCENTUAL = CASE WHEN NVL(X.TOTAL, 0) = 0 THEN 0 ELSE (X.VRORCAMENTO*100)/X.TOTAL END;
                         
                       END LOOP;
                       COMMIT;
                    END;";
                    
        $params = array(
            ":P_IDTIPOORCAOP" => $rowsChecked['IDTIPOORCAOP'],
            ":P_ANO" => $rowsChecked['NRANOORCAGOP'],
            ":P_IDPERIODOORCA" => $rowsChecked['IDPERIODOORCA'],
            ":P_NRPERIODOORCA" => $rowsChecked['NRPERIODOORCA'],
            ":P_NRLISTAFILIAL" => $nrListaFilial,
            ":P_CDORCAMENT" => $rows['CDORCAMENT'],
            ":P_NRLISTA" => $nrLista
        );
        //var_dump($params); die;
        
        try{
            $std = $this->connection->prepare($sqlScript);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
}